<?php

class DeloBankValidationModuleFrontController extends ModuleFrontController
{
    /**
     * Метод создает заказ и перекидывает на страницу оплаты банка
     */
    public function postProcess()
    {
        $cart = $this->context->cart;

        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        $customer = new Customer($cart->id_customer);

        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        $currency = $this->context->currency;
        $total = (float)$cart->getOrderTotal(true, Cart::BOTH);

        $this->module->validateOrder((int)$cart->id, Configuration::get('PS_OS_CHEQUE'), $total, $this->module->displayName, null, [], (int)$currency->id, false, $customer->secure_key);
        $this->redirectToBankPage($this->module->currentOrder, $cart->id, $this->module->id, $customer->secure_key);
    }

    /**
     * Перекидывает на страницу банка
     * @param int $orderId
     * @param int $cartId
     * @param int $moduleId
     * @param string $key
     */
    private function redirectToBankPage($orderId, $cartId, $moduleId, $key)
    {
        $merchId = Configuration::get(DeloBank::PREFIX . 'merch_id', '');
        $backUrlSuccessful = $this->context->link->getPageLink('order-confirmation', true, null, ['id_cart' => $cartId, 'id_module' => $moduleId, 'id_order' => $orderId, 'key' => $key]);
        $backUrlFail = Configuration::get(DeloBank::PREFIX . 'back_url_f', '');
        $lang = Configuration::get(DeloBank::PREFIX . 'lang', '');
        $url = Configuration::get(DeloBank::PREFIX . 'url', '');
        $args = [
            'merch_id'    => $merchId,
            'o.order_id'  => $orderId,
            'back_url_s'  => $backUrlSuccessful,
            'back_url_f'  => $backUrlFail,
            'lang'        => $lang,
        ];
        // Перебрасываем на стартовую страницу платежного шлюза
        $url .= '?' . http_build_query($args);
        Tools::redirect($url);
    }
}
